<template>
	<div>
		<Map :markers="mapMarkers" :center="mapCenter" ></Map>
		<v-container grid-list-xl class="n-step-container">
			<v-layout row wrap>
				<v-flex xs8 class="n-col">
					<v-layout wrap align-content-center>
						<v-flex xs12 md6>
							<div class="mdc-form-row">
								<mc-control-label >Location</mc-control-label>
								<mc-select
									id="location"
									outlined
									enhanced
									:float="false"
									name="city"
									v-model="campaign.city"
									v-validate="'required'"
									data-vv-scope="n-step2"
									@change="onChangeCity"
									placeholder="Select a city"
									:options="cities"
									class="n-input"
								>
								</mc-select>
								<span v-show="errors.has('city')" class="red--text">
								{{ errors.first('city') }}
							</span>
							</div>
						</v-flex>
					</v-layout>
					<v-layout row wrap>
						<v-flex xs12 md12>
							<div class="mdc-form-row">
								<mc-control-label >District</mc-control-label>
								<v-combobox
									placeholder="Select a district(s)"
									:items="districts"
									item-text="name"
									item-value="_id"
									multiple
									chips
									solo
									hide-no-data
									v-model="campaign.districts"
									name="district"
									v-validate="'required'"
									@change="onChangeDistricts"
									append-icon="add"
									class="mdc-combobox"
									hide-details
								>
									<template slot="selection" slot-scope="{item, parent, selected}" >
										<v-chip color="error" text-color="#fff" >
											<v-icon left small @click="parent.selectItem(item)">close</v-icon>
											{{ item.name || getDistrictText(item) }}
										</v-chip>
									</template>
								</v-combobox>
							</div>
							<span v-show="errors.has('district')" class="red--text">
										{{ errors.first('district') }}
									</span>
						</v-flex>
					</v-layout>
					<v-layout row wrap>
						<v-flex xs12 md12 class="n-form-item">
							<div class="mdc-form-row">
								<mc-control-label >Near by</mc-control-label>
								<v-combobox
									placeholder="Select a nearby(s)"
									:items="nears_by"
									item-text="name"
									item-value="id"
									multiple
									chips
									solo
									hide-no-data
									v-model="campaign.nearby"
									name="nearby"
									@change="onChangeNearby"
									append-icon="add"
									class="mdc-combobox"
									hide-details
								>
									<template slot="selection" slot-scope="{ item, parent, selected }">
										<v-chip color="error" text-color="#fff">
											<v-icon left small @click="parent.selectItem(item)">close</v-icon>
											{{ item.name || getNearByText(item) }}
										</v-chip>
									</template>
								</v-combobox>
							</div>
						</v-flex>
					</v-layout>
					<v-layout row wrap>
						<v-flex xs12>
							<div class="mdc-form-row time-section">
								<mc-control-label >Time</mc-control-label>
								<v-layout row wrap>
									<v-flex sm6>
										<div class="time-title">
											<span>Start date</span>
										</div>
										<input
											type="hidden"
											v-model="campaign.available.from"
											v-validate="'less_than_eq:toDate'"
											name="fromDate">
										<v-menu
											ref="startDateEl"
											v-model="isShowStartDate"
											:close-on-content-click="false"
											:nudge-right="40"
											lazy
											transition="scale-transition"
											offset-y
											full-width
											max-width="290px"
											min-width="290px"
										>
											<template v-slot:activator="{ on }">
												<v-text-field
													:value="campaign.available.from | dateFormat"
													placeholder="DD M YYY"
													persistent-hint
													hide-details
													solo
													v-on="on"
												>
													<template slot="prepend-inner" class="v-input__prepend-inner--img">
														<v-img
															class="v-input__prepend-inner--img"
															contain
														>
															<img src="@/assets/images/icons/calendar-icon.png">
														</v-img>
													</template>
												</v-text-field>
											</template>
											<v-date-picker
												:value="campaign.available.from | dateFormat('YYYY-MM-DD')" no-title
												:min="minDate"
												color="error"
												@input="onChangeStartDate"></v-date-picker>
										</v-menu>
										<span v-show="errors.has('fromDate')" class="red--text">
										{{ errors.first('fromDate') }}
									</span>
									</v-flex>
									<v-flex sm6>
										<div class="time-title">
											<span>Start time</span>
										</div>
										<input
											type="hidden"
											v-model="startDateTime"
											v-validate="'less_than_eq:toFormatValue'"
											name="fromTime">
										<v-menu
											ref="startTimeEl"
											v-model="isShowStartTimeDialog"
											:close-on-content-click="false"
											:nudge-right="40"
											lazy
											transition="scale-transition"
											offset-y
											full-width
											max-width="290px"
											min-width="290px"
										>
											<template v-slot:activator="{ on }">
												<v-text-field
													:value="campaign.times.from | timeFormat"
													label="HH:mm"
													readonly
													solo
													v-on="on"
													hide-details
												>
													<template slot="prepend-inner" class="v-input__prepend-inner--img">
														<v-img
															class="v-input__prepend-inner--img"
															contain
														>
															<img src="@/assets/images/icons/clock-icon.png">
														</v-img>
													</template>
												</v-text-field>
											</template>
											<v-time-picker
												v-if="isShowStartTimeDialog"
												:value="campaign.times.from | timeFormat"
												full-width
												color="error"
												@click:minute="$refs.startTimeEl.save(timeFormat(campaign.times.from))"
												@change="onChangeStartTime"
											></v-time-picker>
										</v-menu>
										<span v-show="errors.has('fromTime')" class="red--text">
											{{ errors.first('fromTime') }}
										</span>
									</v-flex>
									<v-spacer></v-spacer>
									<v-flex sm6>
										<div class="time-title">
											<span>End date</span>
										</div>
										<input
											type="hidden"
											v-model="campaign.available.to"
											name="toDate"
											ref="toDate">
										<v-menu
											ref="endDateEl"
											v-model="isShowEndDate"
											:close-on-content-click="false"
											:nudge-right="40"
											lazy
											transition="scale-transition"
											offset-y
											full-width
											max-width="290px"
											min-width="290px"
										>
											<template v-slot:activator="{ on }">
												<v-text-field
													:value="campaign.available.to | dateFormat"
													placeholder="DD M YYY"
													persistent-hint
													solo
													v-on="on"
													hide-details
												>
													<template slot="prepend-inner" class="v-input__prepend-inner--img">
														<v-img
															class="v-input__prepend-inner--img"
															contain
														>
															<img src="@/assets/images/icons/calendar-icon.png">
														</v-img>
													</template>
												</v-text-field>
											</template>
											<v-date-picker
												:value="campaign.available.to | dateFormat('YYYY-MM-DD')"
												:min="minDate"
												no-title
												color="error"
												@input="onChangeEndDate"></v-date-picker>
										</v-menu>
										<span v-show="errors.has('.toDate')" class="red--text">
										{{ errors.first('toDate') }}
									</span>
									</v-flex>
									<v-flex sm6>
										<div class="time-title">
											<span>End time</span>
										</div>
										<input
											type="hidden"
											v-model="endDateTime"
											name="toFormatValue"
											ref="toFormatValue">
										<v-menu
											ref="endTimeEl"
											v-model="isShowEndTimeDialog"
											:close-on-content-click="false"
											:nudge-right="40"
											lazy
											transition="scale-transition"
											offset-y
											full-width
											max-width="290px"
											min-width="290px"
										>
											<template v-slot:activator="{ on }">
												<v-text-field
													:value="campaign.times.to | timeFormat"
													placeholder="HH:mm"
													readonly
													solo
													v-on="on"
													hide-details
												>
													<template slot="prepend-inner" class="v-input__prepend-inner--img">
														<v-img
															class="v-input__prepend-inner--img"
															contain
														>
															<img src="@/assets/images/icons/clock-icon.png">
														</v-img>
													</template>
												</v-text-field>
											</template>
											<v-time-picker
												v-if="isShowEndTimeDialog"
												:value="campaign.times.to | timeFormat"
												full-width
												color="error"
												@click:minute="$refs.endTimeEl.save(timeFormat(campaign.times.to))"
												@change="onChangeEndTime"
											></v-time-picker>
										</v-menu>
										<span v-show="errors.has('to')" class="red--text">
										{{ errors.first('to') }}
										</span>
									</v-flex>
								</v-layout>
							</div>
						</v-flex>
						<v-flex xs6>
							<div class="mdc-form-row">
								<mc-control-label >Budget</mc-control-label>
								<mc-input-number
									type="number"
									placeholder="Enter budget"
									v-model="campaign.budget"
									name="budget"
									v-validate="'decimal|min_value:50'"
									@change="onCalculateCost"
								>
									<i class="n-icon n-usd" slot="prepend-icon">$</i>
								</mc-input-number>
								<span v-show="errors.has('budget')" class="red--text">
											{{ errors.first('budget') }}
										</span>
							</div>
						</v-flex>
					</v-layout>
					<div class="n-options">
						<v-flex xs12>
							<Audience></Audience>
						</v-flex>
						<v-flex xs12>
							<Environment></Environment>
						</v-flex>
					</div>
				</v-flex>
				<v-flex xs4 class="n-col n-calc-sidebar">
					<div class="n-calc-sidebar-inner">
						<v-flex pa-0 xs12>
							<v-card flat class="calc-item first">
								<v-layout row wrap>
									<v-flex pa-0 xs3 class="n-calc-box">
										<v-img
											class="n-item-img"
											:src="require('@/assets/images/icons/car-icon.png')"
											contain
										>
										</v-img>
									</v-flex>
									<v-flex pa-0 xs9>
										<div>
											<v-card-title>
												<div>
													<div class="calc-item-title">Number of cars/devices
													</div>
												</div>
											</v-card-title>
											<v-card-actions>
												<span class="num-item">{{campaign.costInfo.devices}}</span>
											</v-card-actions>
										</div>
									</v-flex>
								</v-layout>
							</v-card>
						</v-flex>
						<v-flex pa-0 xs12>
							<v-card flat class="calc-item">
								<v-layout>
									<v-flex pa-0 xs3 class="n-calc-box">
										<v-img
											class="n-item-img"
											:src="require('@/assets/images/icons/viewers-icon.png')"
											contain
										></v-img>
									</v-flex>
									<v-flex pa-0 xs9>
										<div>
											<v-card-title primary-title class="n-card-title">
												<div>
													<div class="calc-item-title">Estimated viewer's
														population
													</div>
												</div>
											</v-card-title>
											<v-card-actions>
												<span class="num-item">{{campaign.costInfo.viewer}}</span>
											</v-card-actions>
										</div>
									</v-flex>
								</v-layout>
							</v-card>
						</v-flex>
						<v-flex pa-0 xs12>
							<v-card flat class="calc-item">
								<v-layout>
									<v-flex pa-0 xs3 class="n-calc-box">
										<v-img
											class="n-item-img"
											:src="require('@/assets/images/icons/impression-icon.png')"

											contain
										></v-img>
									</v-flex>
									<v-flex pa-0 xs9>
										<div>
											<v-card-title primary-title>
												<div>
													<div class="calc-item-title">Impressions</div>
												</div>
											</v-card-title>
											<v-card-actions>
												<span class="num-item">{{campaign.costInfo.impressions}}</span>
											</v-card-actions>
										</div>
									</v-flex>
								</v-layout>
							</v-card>
						</v-flex>
						<v-flex pa-0 xs12>
							<v-card flat class="calc-item">
								<v-layout>
									<v-flex xs12>
										<div>
											<v-card-title primary-title class="n-center">
												<div>
													<div class="n-total-title">Total Cost</div>
												</div>
											</v-card-title>
											<v-card-actions class="n-center">
												<span class="n-total">${{campaign.costInfo.totalCost}}</span>
											</v-card-actions>
										</div>
									</v-flex>
								</v-layout>
							</v-card>
						</v-flex>
					</div>
				</v-flex>
			</v-layout>
		</v-container>
		<v-container class="n-container">
			<div class="n-row">
				<v-layout wrap>
					<v-flex class="mdc-text-right mdc-m--top-15 mdc-p--top-15">
						<v-btn round color="default" @click="$emit('cancel', {message: localed.leave } )">Cancel</v-btn>
						<v-btn
							round
							color="primary"
							@click="save"
						>
							Save
						</v-btn>
					</v-flex>
				</v-layout>
			</div>
		</v-container>
	</div>
</template>
<script src="./Campaign.js"></script>
